#
# Conditional build:
%bcond_with	qbs		# package Qbs build tool
%bcond_without	webengine	# QtWebEngine based help viewer

%ifnarch %{x8664} aarch64
%undefine	with_webengine
%endif

%define		qtver	6.4.3

Summary:	An IDE tailored to the needs of Qt developers
Summary(pl.UTF-8):	IDE dostosowane do potrzeb programistów Qt
Name:		qt-creator
Version:	13.0.1
Release:	4
Epoch:		1
License:	LGPL v2.1
Group:		X11/Development/Tools
Source0:	https://download.qt.io/official_releases/qtcreator/13.0/%{version}/%{name}-opensource-src-%{version}.tar.xz
# Source0-md5:	4e7cb5c7c0287b9c3c838b8c436a35b8
URL:		https://doc.qt.io/qtcreator/
BuildRequires:	Qt6Concurrent-devel >= %{qtver}
BuildRequires:	Qt6Designer-devel >= %{qtver}
BuildRequires:	Qt6Gui-devel >= %{qtver}
BuildRequires:	Qt6Help-devel >= %{qtver}
BuildRequires:	Qt6Network-devel >= %{qtver}
BuildRequires:	Qt6PrintSupport-devel >= %{qtver}
BuildRequires:	Qt6Qml-devel >= %{qtver}
BuildRequires:	Qt6Qt5Compat-devel >= %{qtver}
BuildRequires:	Qt6Quick-devel >= %{qtver}
BuildRequires:	Qt6SerialPort-devel >= %{qtver}
BuildRequires:	Qt6ShaderTools-devel >= %{qtver}
BuildRequires:	Qt6Sql-devel >= %{qtver}
BuildRequires:	Qt6Svg-devel >= %{qtver}
BuildRequires:	Qt6UiTools-devel >= %{qtver}
%{?with_webengine:BuildRequires:	Qt6WebEngine-devel >= %{qtver}}
BuildRequires:	Qt6Widgets-devel >= %{qtver}
BuildRequires:	Qt6Xml-devel >= %{qtver}
BuildRequires:	clang-devel >= 6.0.0
BuildRequires:	cmake >= 3.16
BuildRequires:	gdb
BuildRequires:	libstdc++-devel >= 6:7
BuildRequires:	llvm-devel >= 7.0.0
BuildRequires:	qt6-build >= %{qtver}
BuildRequires:	qt6-linguist
BuildRequires:	qt6-shadertools
BuildRequires:	rpmbuild(macros) >= 1.742
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRequires:	yaml-cpp-devel >= 0.8
Requires(post,postun):	desktop-file-utils
%requires_eq	Qt6Core
Requires:	Qt6Gui-platform-xcb
Requires:	Qt6Sql-sqldriver-sqlite3
Requires:	hicolor-icon-theme
Requires:	qt5-qtdeclarative
# for xdg-open
Suggests:	xdg-utils
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		skip_post_check_so	'libClangsupport\.so.*'

%description
Qt Creator is a cross-platform integrated development environment
(IDE) tailored to the needs of Qt developers.

%description -l pl.UTF-8
Qt Creator to wieloplatformowe IDE dostosowane do potrzeb programistów
Qt.

%prep
%setup -q -n %{name}-opensource-src-%{version}

sed -i '1s,/usr/bin/env python,%{__python},' src/shared/qbs/src/3rdparty/python/lib/python3.9/site-packages/dmgbuild/__main__.py

%build
%cmake -B build \
	%{cmake_on_off qbs BUILD_QBS} \
	%{cmake_on_off webengine BUILD_HELPVIEWERBACKEND_QTWEBENGINE}

%{__make} -C build

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_desktopdir}

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d
echo "%{_libdir}/qtcreator" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/qtcreator.conf
cp -p share/applications/org.qt-project.qtcreator.desktop $RPM_BUILD_ROOT%{_desktopdir}

rm -f $RPM_BUILD_ROOT%{_libdir}/qtcreator/*.prl

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
%update_desktop_database
%update_icon_cache hicolor

%postun
/sbin/ldconfig
%update_desktop_database_postun
%update_icon_cache hicolor

%files
%defattr(644,root,root,755)
%if %{with qbs}
%attr(755,root,root) %{_bindir}/qbs
%attr(755,root,root) %{_bindir}/qbs-config
%attr(755,root,root) %{_bindir}/qbs-config-ui
%attr(755,root,root) %{_bindir}/qbs-create-project
%attr(755,root,root) %{_bindir}/qbs-setup-android
%attr(755,root,root) %{_bindir}/qbs-setup-qt
%attr(755,root,root) %{_bindir}/qbs-setup-toolchains
%endif
%attr(755,root,root) %{_bindir}/qtcreator
%{_sysconfdir}/ld.so.conf.d/qtcreator.conf
%dir %{_libexecdir}/qtcreator
%attr(755,root,root) %{_libexecdir}/qtcreator/buildoutputparser
%attr(755,root,root) %{_libexecdir}/qtcreator/cpaster
%{?with_qbs:%attr(755,root,root) %{_libexecdir}/qtcreator/dmgbuild}
%attr(755,root,root) %{_libexecdir}/qtcreator/perf2text
%attr(755,root,root) %{_libexecdir}/qtcreator/perfparser
%attr(755,root,root) %{_libexecdir}/qtcreator/qtcreator_processlauncher
%{?with_qbs:%attr(755,root,root) %{_libexecdir}/qtcreator/qbs_processlauncher}
%attr(755,root,root) %{_libexecdir}/qtcreator/qml2puppet-%{version}
%attr(755,root,root) %{_libexecdir}/qtcreator/qtcreator_process_stub
%attr(755,root,root) %{_libexecdir}/qtcreator/qtc-askpass
%attr(755,root,root) %{_libexecdir}/qtcreator/qtpromaker
%attr(755,root,root) %{_libexecdir}/qtcreator/sdktool
%dir %{_libdir}/qtcreator
%attr(755,root,root) %{_libdir}/qtcreator/lib*.so.*.*
%attr(755,root,root) %ghost %{_libdir}/qtcreator/lib*.so.13
%dir %{_libdir}/qtcreator/plugins
%attr(755,root,root) %{_libdir}/qtcreator/plugins/lib*.so
%if %{with qbs}
%dir %{_libdir}/qtcreator/plugins/qbs
%dir %{_libdir}/qtcreator/plugins/qbs/plugins
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qbs/plugins/libclangcompilationdbgenerator.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qbs/plugins/libiarewgenerator.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qbs/plugins/libkeiluvgenerator.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qbs/plugins/libmakefilegenerator.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qbs/plugins/libqbs_cpp_scanner.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qbs/plugins/libqbs_qt_scanner.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qbs/plugins/libvisualstudiogenerator.so
%endif
%dir %{_libdir}/qtcreator/plugins/qmldesigner
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qmldesigner/libassetexporterplugin.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qmldesigner/libcomponentsplugin.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qmldesigner/libqmlpreviewplugin.so
%attr(755,root,root) %{_libdir}/qtcreator/plugins/qmldesigner/libqtquickplugin.so
%{_datadir}/qtcreator
%{_datadir}/metainfo/org.qt-project.qtcreator.appdata.xml
%{_desktopdir}/org.qt-project.qtcreator.desktop
%{_iconsdir}/hicolor/*x*/apps/QtProject-qtcreator.png
%changelog
* Mon Sep 30 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/qt-creator.git;a=log;h=master

* Mon Sep 30 2024 Jan Palus <atler@pld-linux.org> 3bb76b7
- qt6 6.7.3 rebuild

* Thu Jun 20 2024 Jan Rękorajski <baggins@pld-linux.org> 4ce2161
- Release 3 (by relup.sh)

* Mon Jun 10 2024 Jan Palus <atler@pld-linux.org> e2a1113
- llvm 18.1 rebuild

* Mon Jun 03 2024 Jan Palus <atler@pld-linux.org> 8b2478c
- up to 13.0.1

* Tue Apr 02 2024 Jan Palus <atler@pld-linux.org> 0e9e8c0
- up to 12.0.2

* Wed Feb 28 2024 Jan Palus <atler@pld-linux.org> 6c29ee4
- qt6 6.6.2 rebuild

* Wed Nov 29 2023 Jan Palus <atler@pld-linux.org> 1d4fc54
- qt6 6.6.1 rebuild

* Fri Nov 03 2023 Jan Palus <atler@pld-linux.org> bb5c876
- llvm 17 rebuild

* Thu Oct 26 2023 Jan Rękorajski <baggins@pld-linux.org> 7f721a0
- Release 3 (by relup.sh)

* Fri Sep 29 2023 Jan Rękorajski <baggins@pld-linux.org> 6d441bb
- Release 2 (by relup.sh)

* Thu Aug 31 2023 Jakub Bogusz <qboosh@pld-linux.org> 9ba7c27
- updated to 11.0.2, added yaml-cpp patch to fix build with yaml-cpp 0.8

* Sat Jul 22 2023 Jan Palus <atler@pld-linux.org> 6fb32a8
- qt6 rebuild

* Thu May 25 2023 Jan Palus <atler@pld-linux.org> 0a14b11
- llvm/qt6 rebuild

* Wed Apr 12 2023 Jan Palus <atler@pld-linux.org> 6ab8b4f
- disable qbs

* Tue Apr 11 2023 Jan Palus <atler@pld-linux.org> 399164e
- up to 10.0.0

* Fri Mar 17 2023 Jan Palus <atler@pld-linux.org> d65a65e
- qt6 rebuild

* Fri Jan 06 2023 Jan Palus <atler@pld-linux.org> caa939d
- qt6 rebuild

* Thu Nov 17 2022 Jan Palus <atler@pld-linux.org> d8ef93d
- qt6 rebuild

* Sun Nov 06 2022 Jan Rękorajski <baggins@pld-linux.org> 9e534c4
- Release 3 (by relup.sh)

* Wed Nov 02 2022 Jan Palus <atler@pld-linux.org> d846fab
- qt6 rebuild

